#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.16 $
#
#   last change: $Author: vg $ $Date: 2003-04-15 14:42:16 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..

PRJNAME=bridges
TARGET=urp_uno
ENABLE_EXCEPTIONS=TRUE
NO_BSYMBOLIC=TRUE
USE_DEFFILE=TRUE

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# ------------------------------------------------------------------

.IF "$(COM)$(OS)" == "GCCMACOSX"
CFLAGS += -Duno_initEnvironment=$(TARGET)uno_initEnvironment \
      -Duno_ext_getMapping=$(TARGET)uno_ext_getMapping
.ENDIF


SLOFILES= 	\
        $(SLO)$/urp_environment.obj \
        $(SLO)$/urp_marshal.obj \
        $(SLO)$/urp_unmarshal.obj \
        $(SLO)$/urp_dispatch.obj \
        $(SLO)$/urp_job.obj \
        $(SLO)$/urp_reader.obj \
        $(SLO)$/urp_writer.obj \
        $(SLO)$/urp_log.obj \
        $(SLO)$/urp_bridgeimpl.obj \
        $(SLO)$/urp_propertyobject.obj \
        $(SLO)$/urp_threadid.obj

.IF "$(COM)"=="GCC"
NOOPTFILES= \
        $(SLO)$/urp_reader.obj
.ENDIF			# "$(COM)"=="GCC"

SHL1TARGET= $(TARGET)

SHL1DEF=$(MISC)$/$(SHL1TARGET).def
SHL1VERSIONMAP=..$/..$/bridge_exports.map

SHL1STDLIBS=\
        $(SALLIB)\
        $(CPPULIB)

SHL1LIBS=\
            $(SLB)$/$(TARGET).lib \
            $(SLB)$/bridges_remote_static.lib

DEF1NAME=   $(SHL1TARGET)

# --- Targets ------------------------------------------------------

.INCLUDE :	target.mk

